//---------------------------------------------------------------------------
// Copyright 1999 Andreas Huennebeck
//
// Licensed under the terms of the GNU General Public License.
// ABSOLUTELY NO WARRANTY. See the file `COPYING' in this distribution.
//
// $Source: /home/ah/CvsTree/daten/src/libAHio/TestRiffChunk.c,v $
// $Id: 
//
// Description: 
//
//---------------------------------------------------------------------------

static const char rcsid[] = "$Id: TestRiffChunk.c,v 1.2 2000/02/27 01:52:16 ah Exp $ (c) 1999 Andreas Huennebeck";

// --- necessary includes ---

#include <AH/IO/Riff/Chunk.h>	// my interface first, says Lakos
#include <AH/IO/CFormat.h>
#include <AH/IO/Smart/FilePtr.h>
#include <AH/IO/Smart/Buffer.h>

USING_NAMESPACE(AH)

#include <iostream>
USING_NAMESPACE(std)

unsigned int execute_test
(
    const unsigned char*	buf,
    unsigned int		size
)
{
    // get RIFF info from file data in buffer:
    IORiffChunk chunk(buf);
    chunk.printInfo(cout);

    cout << "ID of chunk          = " << chunk.getID() << endl;
    cout << "size of chunk data   = " << chunk.getDataSize() << endl;
    cout << "size of chunk        = " << chunk.getChunkSize() << endl;
    cout << "offset to next chunk = " << chunk.nextChunk() - buf 
	 << " bytes" << endl;
    cout << "offset to chunk data = " << chunk.chunkData() - buf 
	 << " bytes" << endl;
    IORiffChunk wave(buf+12);
    wave.printInfo(cout);
    cout << "ID of chunk          = " << wave.getID() << endl;
    cout << "size of chunk data   = " << wave.getDataSize() << endl;
    cout << "size of chunk        = " << wave.getChunkSize() << endl;
    cout << "offset to next chunk = " << wave.nextChunk() - buf 
	 << " bytes" << endl;
    cout << "offset to chunk data = " << wave.chunkData() - buf 
	 << " bytes" << endl;
    return 0;
}



int main(int argc, char* argv[])
{
    cerr << "Test of " << argv[0] << ":" << endl;

    unsigned int errnum = 0;
    for (int i=1; i < argc; i++)
    {
	string filename(argv[i]);
	cerr << "processing " << filename << " ..." << endl;

	IOSmartFilePtr file(filename, "r");
	IOSmartBuffer<unsigned char> buf(1024);
	if (0 == fread(buf(), buf.getSize(), 1, file())) 
	    throw ErrorSys("cannot open " + filename);
	errnum += execute_test(buf(), 1024);
    }

    // print test results:
    cerr << argv[0] << ": ";
    if (errnum)
    {
	cerr << "failed with " << errnum << " error"
	     << (errnum > 1 ? "s" : "") << ". stop." << endl;
	return 1;;
    }
    cerr << "passed." << endl;
    return 0;
}
