//---------------------------------------------------------------------------
// Copyright 2000 Andreas Huennebeck
//
// Licensed under the terms of the GNU General Public License.
// ABSOLUTELY NO WARRANTY. See the file `COPYING' in this distribution.
//
// $Source: /home/ah/CvsTree/daten/src/mpegtools/fileset.h,v $
// $Id: fileset.h,v 1.1 2000/10/11 19:43:26 ah Exp $ 
//
// Description: cut a pice out of a mp3 file into a new mp3 file
//
//---------------------------------------------------------------------------

#ifndef AH_MP3TOOL_FILESET_H
#define AH_MP3TOOL_FILESET_H

// --- necessary includes ---
#include <AH/Config/Platform.h> // always the first include
#include <AH/Config/Types.h>
USING_NAMESPACE(AH)

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h> 
#include <iostream>
#include <fstream>
#include <vector>
#include <string>
USING_NAMESPACE(std)

#include <AH/Error/Class.h>
#include <AH/Error/Basic.h>
USING_NAMESPACE(AH)

// --- classes ---

class FileSettings
{
 public:
    /// add new file name
    void addFileName(const string& name);
    /// add frame settings
    void addFrameRange(const string& sr);
    /// add time settings
    void addTimeRange(const string& sr);

    /// get number of entries
    unsigned int getNum() const;

    /// get specified filename
    const string& getFileName(unsigned int i) const;

    /// get specified frame range
    const string& getFrameRange(unsigned int i) const;
    /// get specified frame range
    void getFrameRange(unsigned int i, int& f1, int& f2) const;

    /// get specified time range
    const string& getTimeRange(unsigned int i) const;
    /// get specified time range
    void getTimeRange(unsigned int i, double& t1, double& t2) const;

 private:
    vector<string> fileName;
    vector<string> frameRange;
    vector<string> timeRange;
    string empty;

}; // class FileSettings


#endif // AH_MP3TOOL_FILESET_H
// --- end of file ---
